"use strict";

var browser = {}, app, Port, _, LNG, cfg;

if (document instanceof window.HTMLDocument) {
	browser = document.documentElement || document.createElementNS("http://www.w3.org/1999/xhtml", "div");

	if (!window.requestAnimationFrame) {
		window.requestAnimationFrame = window.webkitRequestAnimationFrame
			|| window.mozRequestAnimationFrame || function(cb) { return window.setTimeout(cb, 20); };
	}

	if (browser.style) {
		_ = browser.style;

		browser = {
			"wheel": "onwheel" in browser ? "wheel" : "mousewheel", // Firefox <17 uses DOMMouseScroll, corrected below
			"transform": ("webkitTransform" in _ ? "webkitT" : ("OTransform" in _ ? "OT" : ("MozTransform" in _ ? "MozT" : "t"))) + "ransform",
			"transform_css": ("webkitTransform" in _ ? "-webkit-" : ("OTransform" in _ ? "-o-" : ("MozTransform" in _ ? "-moz-" : ""))) + "transform",
			"transition_css": ("webkitTransition" in _ ? "-webkit-" : ("OTransition" in _ ? "-o-" : ("MozTransition" in _ ? "-moz-" : ""))) + "transition",
			"transitionend": "webkitTransition" in _ ? "webkitTransitionEnd" : ("OTransition" in _ ? "oTransitionEnd" : "transitionend"),
			"box-sizing_css": ("MozBoxSizing" in _ ? "-moz-" : ("WebkitBoxSizing" in _ ? "-webkit-" : "")) + "box-sizing",
			"zoom-in": this.chrome || this.mx || this.safari ? "-webkit-zoom-in" : "zoom-in" // Firefox <24 needs -moz-, corrected below
		};
	}
}

app = {
	"name": /*~APP_NAME~*/"Viewhance",
	"version": /*~APP_VERSION~*/"0.9"
};


Port = {};

if (location.host === app.name.toLowerCase()) {
	Port.bgProcess = Components.classes["@mozilla.org/appshell/appShellService;1"]
					.getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow
					.document.getElementById(app.name + "_bgProcess").contentWindow;

	_ = new Port.bgProcess.extension._(location.pathname.slice(9, location.pathname.indexOf(".", 1)));
	cfg = Port.bgProcess.cfg;
	Port.bgProcess = Port.bgProcess.Port;
}
else {
	app = extension.app;
	_ = extension._;
	Port.bgProcess = extension;
}

browser.firefox = true;

if (app.platform_version < 24) {
	browser["zoom-in"] = "-moz-" + browser["zoom-in"];

	if (app.platform_version < 17) {
		browser.wheel = "DOMMouseScroll";
	}
}

Port.listen = function(listener) {
	this.postMessage = listener;
};

Port.send = function(msg) {
	Port.bgProcess.postMessage({
		data: msg,
		source: Port,
		origin: window.location.href
	});
};

