"use strict";

var app, cfg, Tabs, Port;

app = {
	"name": /*~APP_NAME~*/"Viewhance",
	"version": /*~APP_VERSION~*/"0.9"
};


var Cc = Components.classes, Ci = Components.interfaces;

Components.utils["import"]("resource://gre/modules/Services.jsm");

Port = (Services.appshell || Cc["@mozilla.org/appshell/appShellService;1"].getService(Ci.nsIAppShellService))
			.hiddenDOMWindow.document.getElementById(app.name + "_bgProcess");

(Port.wrappedJSObject || Port).initBgProcess(window);

app.platform_version = extension.app.platform_version;
app.baseURI = extension.app.baseURI;

// TODO: store in files/sql instead (at least the sieve)
cfg = {
	PB: Services.prefs.getBranch("extensions." + app.name + "."),
	str: Cc["@mozilla.org/supports-string;1"].createInstance(Ci.nsISupportsString),
	getItem: function(k, fn) {
		try {
			fn(this.PB.getComplexValue(k, Ci.nsISupportsString).data);
		} catch (ex) {
			return null;
		}
	},
	setItem: function(k, v) {
		this.str.data = v;
		this.PB.setComplexValue(k, Ci.nsISupportsString, this.str);
	}
};

/*Tabs = {
	rgxNoLocal: /^[^:]{2,20}:/,
	curWin: function() {
		return Services.wm.getMostRecentWindow("navigator:browser");
	},
	getSelected: function(cb) {
		var win = this.curWin();
		cb(win && win.gBrowser ? win.gBrowser.selectedTab : {});
	},
	create: function(p) {
		var win = this.curWin();

		if (win) {
			if (!this.rgxNoLocal.test(p["url"])) {
				p["url"] = app.baseURI + p["url"];
			}

			win.gBrowser.loadOneTab(p["url"], {inBackground: !p["active"]});
		}
	}
};*/

Port = {
	parse_msg: function(msg) {
		var message;

		try {
			message = this.clone(msg.data);
		} catch (ex) {
			message = msg.data;
		}

		return {
			msg: message,
			origin: msg.origin,
			postMessage: function(message) {
				msg.source.postMessage(msg.no_clone ? message : Port.clone(message));
			}
		};
	},
	listen: function(func) {
		this.postMessage = function(data) {
			// simulate asynchronous messaging with setTimeout
			setTimeout(function() {
				func(data);
			}, 0);
		};
	},
	clone: function(o, c) {
		if (o === null || typeof o !== "object") {
			return o;
		}

		if (o.constructor === RegExp) {
			return RegExp(o);
		}

		c = new o.constructor;

		for (var i in o) {
			c[i] = this.clone(o[i], null);
		}

		return c;
	}
};
