/* global cfg, Port */
"use strict";

cfg.getItem("cfg", function(v) {
	if (!v) {
		var def_prefs = new XMLHttpRequest;
		def_prefs.overrideMimeType("application/json;charset=utf-8");
		def_prefs.open("GET", "defaults.jsn", false);
		def_prefs.send(null);
		cfg.setItem("cfg", JSON.stringify(JSON.parse(def_prefs.responseText)));
	}
});

function onMessage(ev, origin, postMessage) {
	var e = Port.parse_msg(ev, origin, postMessage), msg = e.msg;

	if (!msg.cmd) {
		return;
	}

	switch (msg.cmd) {
		case "hello":
			cfg.getItem("cfg", function(v) {
				e.postMessage({
					"cmd": "hello",
					"prefs": v
				});
			});
		break;

		case "save":
			cfg.setItem("cfg", JSON.stringify(msg.prefs));
		break;
	}

	return true; // Chrome
}

Port.listen(onMessage);